<script setup>
import { onMounted, reactive, ref } from "vue";
import Api from "../../api";
import TextInput from "../../components/ui/TextInput.vue";
import Button from "../../components/ui/Button.vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";

const store = useStore();
let router = useRouter();
const btnLoading = ref(false);
const form = reactive({
	name: "",
	email: "",
	password: "",
});
const errors = ref({});

const submitForm = async () => {
	btnLoading.value = true;
	try {
		let res = await Api.getInstance().authService().register(form);
		if (res.status == 201) {
			router.replace({ name: "Login", query: { email: res.data.email } });
		}
	} catch (error) {
		if (error.response.status == 422) {
			errors.value = error.response.data.errors;
		}
		if (error.response.status == 401) {
			store.dispatch("notification/add", {
				text: error.response.data.message,
			});
		}
	}
	btnLoading.value = false;
};
</script>

<template>
	<div class="flex-center h-screen">
		<form @submit.prevent="submitForm" class="card flex-col">
			<h1 class="bold mb">Register</h1>
			<div class="mb-2">create new account</div>
			<TextInput
				label="Name"
				placeholder="Enter your name"
				v-model="form.name"
				:error="errors.name"
			/>
			<TextInput
				label="Email"
				placeholder="Enter your email address"
				v-model="form.email"
				:error="errors.email"
			/>
			<TextInput
				label="Password"
				placeholder="Enter your password"
				v-model="form.password"
				:error="errors.password"
			/>
			<div class="flex-center mt-1">
				<router-link :to="{ name: 'Login' }" class="fs8 login">
					Already a user?
				</router-link>
				<Button type="submit" :loading="btnLoading" class="ml-auto">
					Register
				</Button>
			</div>
		</form>
	</div>
</template>

<style scoped lang="scss">
.login {
	color: rgb(6, 80, 200);
}
</style>
